Bug 763618 (GLUSTER-1886)

Summary: log-level mess
Product: [Community] GlusterFS Reporter: Csaba Henk <csaba>
Component: glusterdAssignee: shishir gowda <sgowda>
Status: CLOSED CURRENTRELEASE QA Contact:
Severity: medium Docs Contact:
Priority: low    
Version: mainlineCC: gluster-bugs, lakshmipathi, nsathyan, vijay
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Csaba Henk 2010-10-09 15:09:06 EDT
Actually the client _does_ react to the loglevel change, when I feed it with the Feyerabend quote:

[2010-10-10 00:03:46.797978] I [glusterfsd-mgmt.c:59:mgmt_cbk_spec] mgmt: Volume file changed
[2010-10-10 00:03:47.872566] E [graph.y:372:yyerror] parser: syntax error: line 94 (volume 'pop'): "Feyerabend"
allowed tokens are 'volume', 'type', 'subvolumes', 'option', 'end-volume'()
pending frames:

patchset: git://git.sv.gnu.org/gluster.git
signal received: 11
time of crash: 2010-10-10 00:03:47
configuration details:
argp 1
backtrace 1
dlfcn 1
fdatasync 1
libpthread 1
llistxattr 1
setfsid 1
spinlock 1
epoll.h 1
xattr.h 1
st_atim.tv_nsec 1
package-string: glusterfs 3.1.0git
/host/lib/libc.so.6(+0x325e0)[0x7fbe73d685e0]
glusterfs[0x406b97]
glusterfs[0x406d48]
glusterfs(mgmt_getspec_cbk+0x257)[0x4071a6]
/meta/progs/glusterfs-git/usr/lib/libgfrpc.so.0(rpc_clnt_handle_reply+0x200)[0x7fbe746df1fc]
/meta/progs/glusterfs-git/usr/lib/libgfrpc.so.0(rpc_clnt_notify+0x285)[0x7fbe746df555]
/meta/progs/glusterfs-git/usr/lib/libgfrpc.so.0(rpc_transport_notify+0xd2)[0x7fbe746dcaf2]
/meta/progs/glusterfs-git/usr/lib/glusterfs/3.1.0git/rpc-transport/socket.so(socket_event_poll_in+0x54)[0x7fbe721e7c9e]
/meta/progs/glusterfs-git/usr/lib/glusterfs/3.1.0git/rpc-transport/socket.so(socket_event_handler+0x106)[0x7fbe721e8057]
/meta/progs/glusterfs-git/usr/lib/libglusterfs.so.0(+0x4849f)[0x7fbe7492f49f]
/meta/progs/glusterfs-git/usr/lib/libglusterfs.so.0(+0x486b2)[0x7fbe7492f6b2]
/meta/progs/glusterfs-git/usr/lib/libglusterfs.so.0(event_dispatch+0x85)[0x7fbe7492fa29]
glusterfs(main+0xfb)[0x40646b]
/host/lib/libc.so.6(__libc_start_main+0xfd)[0x7fbe73d54c4d]
glusterfs[0x4032a9]
---------
Segmentation fault (core dumped)
[root@quartz ~]# gdb glusterfs core
GNU gdb (GDB) 7.2
...
Core was generated by `glusterfs -N -l /dev/stdout -s localhost --volfile-id=pop /mnt/gluster0/'.
Program terminated with signal 11, Segmentation fault.
#0  0x0000000000406b97 in is_graph_topology_equal (graph1=0x2550d78, graph2=0x0) at glusterfsd-mgmt.c:213
213             trav2 = graph2->first;
(gdb) bt
#0  0x0000000000406b97 in is_graph_topology_equal (graph1=0x2550d78, graph2=0x0) at glusterfsd-mgmt.c:213
#1  0x0000000000406d48 in glusterfs_volfile_reconfigure (newvolfile_fp=0x25508e0) at glusterfsd-mgmt.c:269
#2  0x00000000004071a6 in mgmt_getspec_cbk (req=0x7fbe723f203c, iov=0x7fbe723f207c, count=1, myframe=0x7fbe730fc0c4) at glusterfsd-mgmt.c:369
#3  0x00007fbe746df1fc in rpc_clnt_handle_reply (clnt=0x253bb48, pollin=0x2550508) at rpc-clnt.c:752
#4  0x00007fbe746df555 in rpc_clnt_notify (trans=0x253bcf8, mydata=0x253bb78, event=RPC_TRANSPORT_MSG_RECEIVED, data=0x2550508) at rpc-clnt.c:865
#5  0x00007fbe746dcaf2 in rpc_transport_notify (this=0x253bcf8, event=RPC_TRANSPORT_MSG_RECEIVED, data=0x2550508) at rpc-transport.c:1142
#6  0x00007fbe721e7c9e in socket_event_poll_in (this=0x253bcf8) at socket.c:1619
#7  0x00007fbe721e8057 in socket_event_handler (fd=6, idx=0, data=0x253bcf8, poll_in=1, poll_out=0, poll_err=0) at socket.c:1733
#8  0x00007fbe7492f49f in event_dispatch_epoll_handler (event_pool=0x2537d88, events=0x253d7d8, i=0) at event.c:812
#9  0x00007fbe7492f6b2 in event_dispatch_epoll (event_pool=0x2537d88) at event.c:876
#10 0x00007fbe7492fa29 in event_dispatch (event_pool=0x2537d88) at event.c:984
#11 0x000000000040646b in main (argc=8, argv=0x7fffa604e048) at glusterfsd.c:1410
(gdb)
Comment 1 Csaba Henk 2010-10-09 18:03:46 EDT
Docs say:

diagnostics.brick-log-level           ( yes/no )
diagnostics.client-log-level          ( yes/no )

Contrary to docs, the range of accepted log level argument settings is not bound to the yes/no set. Far from that:

# gluster volume set pop diagnostics.client-log-level "as Feyerabend said, anything goes..."
Set volume successful

... but nothing is taken seriously. The client didn't change its logging behavior, whatever the value of client-log-level was.
Comment 2 Vijay Bellur 2010-10-11 03:32:53 EDT
PATCH: http://patches.gluster.com/patch/5422 in master (Add log-level validation for volume set command)
Comment 3 Anand Avati 2010-10-24 22:43:03 EDT
PATCH: http://patches.gluster.com/patch/5520 in master (Log level mess clean up)
Comment 4 Lakshmipathi G 2010-11-22 02:08:54 EST
verified with 3.1.1qa9

#gluster volume set repd diagnostics.client-log-level "sdfsdf"
Set volume unsuccessful
Invalid log level. possible option are DEBUG|WARNING|ERROR|CRITICAL|NONE|TRACE